

addHook("SpinSpecial", function(player)
		if not player.powers[pw_shield]
		and not (player.pflags & PF_FULLSTASIS)
		and not (player.mo.state == S_PLAY_PAIN)
		and (P_IsObjectOnGround(player.mo) == false) then
		player.mo.state = S_PLAY_RUN
		player.charge = false
		player.pflags = $|PF_THOKKED 
	end
end)


	addHook("PlayerThink", function(player)
		if player.speed < 45*FRACUNIT
		and player.charge == false
		and not player.powers[pw_super]
		and (P_IsObjectOnGround(player.mo) == true) then
				player.mo.state = S_PLAY_RUN
				player.charge = false
				player.pflags = $|PF_SPINNING
				P_Thrust(player.mo, player.mo.angle, 20*FRACUNIT)
		end
		if player.charge == false
		and player.powers[pw_super]
		and player.speed < 60*FRACUNIT
		and (P_IsObjectOnGround(player.mo) == true) then
				player.mo.state = S_PLAY_RUN
				player.charge = false
				player.pflags = $|PF_SPINNING
				P_Thrust(player.mo, player.mo.angle, 50*FRACUNIT)
				P_NukeEnemies(player.mo, player.mo, 1)
				P_StartQuake(20*FRACUNIT, 4)
                end
		if player.charge == false
		and player.speed > 45*FRACUNIT
		and not player.powers[pw_super]
		and (P_IsObjectOnGround(player.mo) == true) then
				player.mo.state = S_PLAY_RUN
				player.charge = false
				player.pflags = $|PF_SPINNING
				P_InstaThrust(player.mo, player.mo.angle, 50*FRACUNIT)
		end
		if player.charge == false
		and player.speed > 60*FRACUNIT
		and player.powers[pw_super]
		and (P_IsObjectOnGround(player.mo) == true) then
				player.mo.state = S_PLAY_RUN
				player.charge = false
				player.pflags = $|PF_SPINNING
				P_Thrust(player.mo, player.mo.angle, 70*FRACUNIT)
				P_NukeEnemies(player.mo, player.mo, 1)
				P_StartQuake(20*FRACUNIT, 4)
		end
	end)
	

addHook("MobjMoveBlocked", function(mo)
    local player = mo.player
    if player.charge == false
	and not player.powers[pw_super]
	P_SetObjectMomZ(player.mo, 10*FRACUNIT + player.speed/4)
	player.charge = false
	player.mo.state = S_PLAY_RUN
	player.pflags = $|PF_SPINNING
	end
end, MT_PLAYER)


addHook("MobjMoveBlocked", function(mo)
    local player = mo.player
    if player.charge == false
	and player.powers[pw_super]
	P_SetObjectMomZ(player.mo, 15*FRACUNIT + player.speed/4)
	player.charge = false
	P_StartQuake(20*FRACUNIT, 4)
	P_NukeEnemies(player.mo, player.mo, 1)
	player.mo.state = S_PLAY_RUN
	player.pflags = $|PF_SPINNING
	end
end, MT_PLAYER)

